#include <iostream>
#include <map>
#include <vector>
#include <string>
#include <stack>
using namespace std;

struct Rate {
    int nom;
    int denom;
    Rate():
        nom(0), denom(0) {}
    Rate(int n, int d):
        nom(n), denom(d)
    {
        int dv = gcd(nom, denom);
        nom /= dv;
        denom /= dv;
    }
    bool valid() const
    {
        return nom && denom;
    }
    Rate reverse() const
    {
        return Rate(denom, nom);
    }
    bool operator==(const Rate& r) const
    {
        return nom*r.denom == denom*r.nom;
    }
    bool operator!=(const Rate& r) const
    {
        return !(*this == r);
    }
    bool operator>(const Rate& r) const
    {
        return nom*r.denom > denom*r.nom;
    }
    bool operator<(const Rate& r) const
    {
        return nom*r.denom < denom*r.nom;
    }
    friend istream& operator>>(istream& is, Rate& r)
    {
        char delim;
        return is >> r.nom >> delim >> r.denom;
    }
    friend ostream& operator<<(ostream& os, const Rate& r)
    {
        return os << r.nom << ":" << r.denom;
    }
    Rate operator*(const Rate& r) const
    {
        return Rate(nom*r.nom, denom*r.denom);
    }
    Rate operator/(int d) const
    {
        return Rate(nom/d, denom/d);
    }
    static int gcd(int A, int B)
    {
        if (B > A) {
            int tmp = A;
            A = B;
            B = tmp;
        }
        int r = A / B;
        int m = A - r * B;
        while (m) {
            A = B;
            B = m;
            r = A / B;
            m = A - r * B;
        }
        return B;
        
    }
};

typedef vector<Rate> XchgTable;
typedef map<string, int> IndexTable;




int mainX(int argc, char* argv[])
{
    int C;
    while (cin >> C) {
        if (!C) break;
        string str;
        
        IndexTable index;
        XchgTable table;
        table.resize(C*C, Rate());
        
        for (int i=0; i<C; i++) {
            cin >> str; 
            index[str] = i;
            table[i+i*C] = Rate(1, 1);
        }
        
        int R;
        cin >> R;
        for (int i=0; i<R; i++) {
            cin >> str;
            int iA = index[str];
            cin >> str;
            int iB = index[str];
            cin >> table[iB+iA*C];
        }
        
        bool cycle = true;
        while (cycle) {
            cycle = false;
            for (int y=0; y<C; y++) {
                for (int x=0; x<C; x++) {
                    const Rate& r1 = table[x+y*C];
                    if (!r1.valid()) continue;
                    for (int q=0; q<C; q++) {
                        const Rate& r2 = table[q+x*C];
                        if (!r2.valid()) continue;
                        Rate& rr = table[q+y*C];
                        Rate r3 = r1*r2;

                        //cout << "("<<y<<","<<x<<") = " << r1 << endl;
                        //cout << "("<<x<<","<<q<<") = " << r2 << endl;
                        //cout << "r1*r2 = " << r3 << endl;
                        //cout << "("<<y<<","<<q<<") = " << rr << endl;
                        if (y == q && r3 < rr) {
                            cout << "Arbitrage" << endl;
                            goto skipout;
                        } else {
                            if (!rr.valid() || r3 < rr) {
                                if (rr.valid()) cycle = true;
                                rr = r3;
                            }
                        }
                    }
                }
            }
        }
        cout << "Ok" << endl;
skipout:;
    }
    return 0;
}

struct Currency
{
    int index;
    vector<Rate> rates;
    vector<int> denomIndex;
    Currency(int i) : index(i) { rates.clear(); denomIndex.clear(); }
    void push(int N, int D, int I)
    {
        rates.push_back(Rate(N, D));
        denomIndex.push_back(i);
    }
    bool check(Rate& rate, const int origIndex, const Rate origRate, vector<Currency>& currencies)
    {
        for (int i = 0; i < rates.size(); i++) {
            Rate r = rates[i];
            if (!currencies[denomIndex[i]].check(r, origIndex, origRate, currencies))
                return false;
        }
        return true;
    }
};


int mainX(int argc, char* argv[])
{
    int C;
    while (cin >> C) {
        if (!C) break;
        string str;
        
        IndexTable index;
        vector<Currency> currencies;
        currencies.resize(C, Currency());
        
        for (int i=0; i<C; i++) {
            cin >> str; 
            index[str] = i
        }
        
        int R;
        cin >> R;
        for (int i=0; i<R; i++) {
            cin >> str;
            int iA = index[str];
            cin >> str;
            int iB = index[str];
            char delim;
            int nom, denom;
            cin >> nom >> delim >> denom;
            currencies[iA].push(nom, denom, iB);
        }
        // go thru each currency
        for (int i = 0; i < C; i++)
        {
            // go thru each of the other currencies
            for (int j = 0; j < currencies[i].rates.size(); j++)
            {
                Rate r = currencies[i].rates[j];
                stack<Currency*> stackC;
                stack<Rate*> stackR;
                stack.push(&currencies[currencies[i].denomIndex[j]]);
                while (stack.size())
                {
                    
                }
            }
        }
    }
    return 0;
}
